import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

import java.util.*;

public class ReportWindow extends JFrame implements ActionListener , WindowListener {
		
	private static ReportWindow instance = null;

	private final String OK = "Ok";
	private final String CONTINUE = "Continue";
	
	private double galsOffset;
	
	private JFrame curGals;
	
	private Color bgcolor = Color.WHITE;
			
	public static ReportWindow getInstance( double offset ) {
		if( instance == null ) instance = new ReportWindow( offset );
		return instance;
	}
	
	protected ReportWindow( double offset ) { super(); galsOffset = offset; this.makeGUI(); }
	
	private void makeGUI() {
		setTitle( "Report" );
		Mileage m = Mileage.getInstance();
		Point p = m.getLocation();
		int x = (int)p.getX();
		int y = (int)p.getY();
		setLocation( x + 100 , y + 100 );
		getContentPane().setBackground( bgcolor );
		getContentPane().setLayout( new GridLayout( 5 , 1 ) );
		setDefaultCloseOperation( JFrame.DO_NOTHING_ON_CLOSE );
		addWindowListener( this );
		addContent();
		pack();
		setVisible( true );
	}
	
	
	
	private void addContent() {
		Mileage mileage = Mileage.getInstance();
		Vector odometer = mileage.getOdometer();
		Vector gallons = mileage.getGallons();
		Vector costs = mileage.getCosts();
		String avgMPG = "Average Miles per Gallon: ";
		String avgMPF = "Average Miles per Fill: ";
		String avgCPG = "Average Cost per Gallon: $";
		String avgCPM = "Average Cost per Mile: $";
		String cost = "Total Amount Spent: $";
		
		double mpg = 0;
		double totalMiles = 0;
		double mpf = 0;
		double cpm = 0;
		double totalGallons = 0;
		double totalCost = 0;
		
		for( int i = 0; i < gallons.size(); i++ ) {
				totalGallons+= (new Double( (String)gallons.get( i ) ).doubleValue() );
		}
		
		for( int i = 0; i < costs.size(); i++ ) {
			totalCost+= (new Double( (String)costs.get( i ) ).doubleValue() );
		}
		
		if( odometer.size() > 1 ) {
			double startMiles = (new Double( (String)odometer.get( 0 ) ).doubleValue() );
			double endMiles = (new Double( (String)odometer.get( odometer.size() - 1 ) ).doubleValue() );
			totalMiles = endMiles - startMiles;
			
			cpm = (totalCost - (new Double(  (String)costs.get( costs.size() - 1 ) ).doubleValue() ) ) / totalMiles;
			
			double gallonsUsed = totalGallons - galsOffset  ;
			mpg = totalMiles / gallonsUsed;
			
			mpf = totalMiles / ( odometer.size() - 1 );
		}
		
		double cpg = totalCost / totalGallons;
		
		avgMPG += mpg;
		int index;
		if( avgMPG.length() > ( index = (avgMPG.lastIndexOf( "." ) + 3) ) )
			avgMPG = avgMPG.substring( 0 , index );
		avgMPF += mpf;
		if( avgMPF.length() > ( index = (avgMPF.lastIndexOf( "." ) + 2) ) )
			avgMPF = avgMPF.substring( 0 , index );
		avgCPG += cpg;
		if( avgCPG.length() > ( index = (avgCPG.lastIndexOf( "." ) + 4) ) )
			avgCPG = avgCPG.substring( 0 , index );
		avgCPM += cpm;
		if( avgCPM.length() > ( index = (avgCPM.lastIndexOf( "." ) + 4) ) )
			avgCPM = avgCPM.substring( 0 , index );
		cost += totalCost;
		
		getContentPane().add( new JLabel( avgMPG ) );
		getContentPane().add( new JLabel( avgMPF ) );
		getContentPane().add( new JLabel( avgCPG ) );
		getContentPane().add( new JLabel( avgCPM ) );
		getContentPane().add( new JLabel( cost ) );
		
	
	}
	
	public void actionPerformed( ActionEvent e ) {
		String command = e.getActionCommand();
		if( command.equals( CONTINUE ) ) dispose();
		
	}
	
	
	public void windowClosing( WindowEvent e ) {
		instance = null;
		dispose();
	}
	
	public void windowActivated( WindowEvent e ) {}
	public void windowClosed( WindowEvent e ) {}
	public void windowDeactivated( WindowEvent e ) {}
	public void windowDeiconified( WindowEvent e ) {}
	public void windowIconified( WindowEvent e ) {}
	public void windowOpened( WindowEvent e ) {}
	
}